%%%
%%% Authors:
%%%   Christian Schulte (schulte@dfki.de)
%%%
%%% Modified By:
%%%    Nils Franzen (nils.franzen@sics.se)
%%%
%%% Copyright:
%%%   Christian Schulte, 1998
%%%   Nils Franzen, 1999
%%%
%%% Last change:
%%%   $Date: 1999/12/09 10:36:22 $ by $Author: nilsf $
%%%   $Revision: 1.2 $
%%%
%%% See the file "LICENSE" or
%%%    http://mozart.ps.uni-sb.de/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

/**
Write html files
*/

functor
import
   Open
export
   out: HtmlOut
prepare
   fun {HtmlStd Body}
      '#'('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">\n' Body)
   end
define
   proc {HtmlOut File Body}
      {New class $
	      from Open.html Open.file
	      prop final
	      meth tag(T)
		 Open.file, init(name:File flags:[write truncate create])
		 Open.html, header
		 Open.html, tag(T)
		 Open.file, close
	      end
	      meth write(vs:VS)=M
		 if {List.isPrefix "Content-type: text/html" {VirtualString.toString VS}}==false then
		    Open.file, M
		 end
	      end
	   end
       tag({HtmlStd Body}) _}
   end
end


