%%%
%%% Authors:
%%%   Nils Franzen (nils.franzen@sics.se)
%%%   Andreas Sundstrom (andreas@sics.se)
%%%
%%% Copyright:
%%%   Nils Franzen, 1999
%%%   Andreas Sundstrom, 1999
%%%
%%% Last change:
%%%   $Date: 1999/12/09 10:36:22 $ by $Author: nilsf $
%%%   $Revision: 1.3 $
%%%
%%% See the file "LICENSE" or
%%%    http://mozart.ps.uni-sb.de/LICENSE.html
%%% for information on usage and redistribution
%%% of this file, and for a DISCLAIMER OF ALL
%%% WARRANTIES.
%%%

functor
export
   SymTable
define
   class SymTable
      prop locking
      feat db
      meth init
	 self.db={NewDictionary}
      end
      meth startScope(name:N info:I env:Env id:ID <= _) Old in
	 lock
	    Old = {Dictionary.condGet self.db N nil}
	    if Old == nil then
	       ID = {Name.new}
	       {Dictionary.put self.db N
		element(info:I env:Env id:ID)|Old}
	    else OldEnv in
	       element(info:_ env:OldEnv id:_) = Old.1
	       if Env \= OldEnv then
		  ID = {Name.new}
		  {Dictionary.put self.db N
		   element(info:I env:Env id:ID)|Old}
	       end
	    end
	 end
      end
      meth updateScope(name:N info:I id:ID <= _) Env Rest in
	 lock try element(info:_ env:Env id:_)|Rest =
		 {Dictionary.condGet self.db N nil}
	      catch failure(...) then
		 raise noScopeFor(N) end
	      end
	    ID = {Name.new}
	    {Dictionary.put self.db N
	     element(info:I env:Env id:ID)|Rest}
	 end
      end
      meth getAllScopes(name:N list:$)
	 lock {Dictionary.condGet self.db N nil} end
      end
      meth getScope(name:N info:I id:Id <= _) 
	 lock try element(info:I env:_ id:Id) =
		 {Dictionary.condGet self.db N nil}.1
	      catch error(...) then
		 raise noScopeFor(N) end
	      end
	 end
      end
      meth condGetScope(name:N info:$ id:Id <= _ default:D) I Found in
	 lock try
		 SymTable, getScope(name:N info:I id:Id)
		 Found = true
	      catch noScopeFor(_) then
		 Found = false
	      end
	    if Found then I else D end
	 end
      end
      meth endScope(env:Env)
	 proc {Pop N}
	    try
	       case {Dictionary.get self.db N}
	       of element(info:_ env:TopEnv id:_)|Stack then
		  if Env == TopEnv then
		     {Dictionary.put self.db N Stack}
		  end
	       [] nil then
		  skip
	       end
	    catch error(...) then
	       raise noScopeFor(N) end
	    end
	 end
	 Keys
      in
	 lock
	    Keys = {Dictionary.keys self.db}
	    {List.forAll Keys Pop}
	 end
      end
      
% Get all keys in this environment
/*
      meth getKeys(env:Env keys:Keys)
	 proc {ThisEnv K}
	    try
	       case {Dictionary.get self.db K}
	       of element(info:_ env:TopEnv id:_)|Stack then
		  Env == TopEnv
	       [] nil then
		  false
	       end
	    catch error(...) then
	       raise noScopeFor(N) end
	    end
	 end
	 Ks
      in
	 lock
	    Ks = {Dictionary.keys self.db}
	    Keys = {List.filter Ks ThisEnv}
	 end
      end	 
*/
      % get keys that contain something
      meth getKeys(keys:Keys)
	 fun {Is K}
	    try
	       case {Dictionary.get self.db K}
	       of _|_ then
		  true
	       [] nil then
		  false
	       end
	    catch error(...) then
	       raise noScopeFor(K) end
	    end 
	 end
	 Ks
      in
	 lock
	    Ks = {Dictionary.keys self.db}
	    Keys = {List.filter Ks Is}
	 end
      end	 
   end
end

/*

declare
[A]={Module.link ['SymTable.ozf']}
ST={New A.symTable init}

{ST startScope(name:foo info:1)}
{ST startScope(name:foo info:2)}

{Browse {ST getAllScopes(name:foo list:$)}}
{Browse {ST getScope(name:foo info:$)}}

{ST endScope(name:foo)}

*/
